// STM32F10X_MD

#include <string.h>
//#include "MyUSART.h"
#include "ssh1106.h"
#include "Main.h"
#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_tim.h"

char str[100];
volatile uint32_t msTicks_200 = 0;

int16_t i;
int enc_cnt;

void init_rotary_encoder()
{
    GPIO_InitTypeDef GPIO_InitStruct;
    // Step 1: Initialize GPIO as input for rotary encoder
    // PB7 (TIM4_CH2) (encoder pin A), PB6 (TIM4_CH1) (encoder pin B)
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOB, ENABLE);

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_7 | GPIO_Pin_6;
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_2MHz;
    GPIO_Init(GPIOB, &GPIO_InitStruct);
    // Step 2: Setup TIM4 for encoder input
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);
    TIM_EncoderInterfaceConfig(TIM4, TIM_EncoderMode_TI12,
		TIM_ICPolarity_Rising, TIM_ICPolarity_Falling);
		TIM_Cmd(TIM4, ENABLE);
}

void UpdateEncoder()
{
    // Get encoder value
    enc_cnt = TIM_GetCounter(TIM4);
    // Print encoder value
    //sprintf(enc_cnt_buf, "%i", enc_cnt);
		LCD_PrintInt(FONT_2X, enc_cnt);				

}	

////////////////////////////////////////////////////////////////////////
int main()
{
	// SetUP SysTimer
	SysTick_Config(SystemCoreClock / 5);      // Configure SysTick to generate an interrupt (max 2^24 tiks)
	//SetUp pinC13 for LED
	RCC->APB2ENR 	|= RCC_APB2ENR_IOPAEN | RCC_APB2ENR_IOPBEN | RCC_APB2ENR_IOPCEN ;
	GPIOC->CRH	&= ~GPIO_CRH_CNF13;	// 00 - GPIO output, Push-Pull 
	GPIOC->CRH 	|= GPIO_CRH_MODE13_1;	// MODE10 = Max Speed 2MHz	
	
	__enable_irq ();	//Enable Global interrupt
	
	Delay_200mS(1);
	SSH1106_Init();
	SSH1106_UpdateDisplay();
	Delay_200mS(1);	

	SSH1106_ClearDisplay();
	SSH1106_UpdateDisplay();
	LcdGotoXYFont(4,1);
	LCD_Print(FONT_1X, "IgiCOM");
	SSH1106_UpdateDisplay();
	LcdGotoXYFont(2,4);
	LCD_Print(FONT_2X, "DISPLAY");				
	SSH1106_UpdateDisplay();
	LcdGotoXYFont(2,7);
	LCD_Print(FONT_2X, "TEST...");				
	SSH1106_UpdateDisplay();

	init_rotary_encoder();
	while (1){
		SSH1106_ClearDisplay();
		
		LcdGotoXYFont(2,1);
		
		LCD_Print(FONT_2X, "Encoder:");				
		enc_cnt = TIM_GetCounter(TIM4);
		LcdGotoXYFont(4,4);
		LCD_PrintInt(FONT_2X, enc_cnt);
		
		SSH1106_UpdateDisplay();	
		Delay_200mS(1);	
	} //do nothing		


}

// utils
//------------------------------------------------------
void Delay_uSec(uint32_t uSec)
{
	uint8_t i;
	while (uSec > 0){
		for (i=0; i<36; i++){
			__nop();		
		}		
		uSec--;
	}

}

//---------------------------------------------------------------
void Delay_200mS( uint32_t Val) 
{
	msTicks_200 = Val;
	while(msTicks_200 > 0){;}
}

//---------------------------------------------------------------
void SysTick_Handler(void)
{
/*	
	if(GPIOC->IDR & GPIO_IDR_IDR13){
		GPIOC->BSRR |= GPIO_BSRR_BR13;
	}else{
		GPIOC->BSRR |= GPIO_BSRR_BS13;
	}
*/	
	if (msTicks_200 > 0){
		msTicks_200--;			// decrement at each 200mS 
	}
	
}



