

#include "MyUSART.h"


void USART_Init(void)
{
	uint32_t temp;
	RCC->APB2ENR 	|=  RCC_APB2ENR_AFIOEN | RCC_APB2ENR_IOPAEN | RCC_APB2ENR_IOPBEN 			 // GPIOA & GPIOB Clock ON. Alter function clock ON
									|	RCC_APB2ENR_USART1EN ; //ENABLE USART 1 
	RCC->APB1ENR |= RCC_APB1ENR_USART2EN;// | RCC_APB1ENR_USART3EN; // And Usart 2, 3
	
	USART1->BRR = (468<<4)|0x0C;		// Baudrate for 9600 on 72Mhz
	USART1->CR1  |= USART_CR1_UE | USART_CR1_TE | USART_CR1_RE | USART_CR1_RXNEIE; // USART1 ON, TX ON, RX ON
	
	//TX1 on PINA9
	GPIOA->CRH	&= ~GPIO_CRH_CNF9; 				// Clear CNF bit 9
	GPIOA->CRH	|= GPIO_CRH_CNF9_1;				// Set CNF bit 9 to 10 - AFIO Push-Pull
	GPIOA->CRH	|= GPIO_CRH_MODE9_0;				// Set MODE bit 9 to Mode 01 = 10MHz
	//RX1 on PINA10	
	GPIOA->CRH	&= ~GPIO_CRH_CNF10;	// Clear CNF bit 10
	GPIOA->CRH	|= GPIO_CRH_CNF10_1;	// Set CNF bit 10 to "10" = PullUp
	GPIOA->CRH	&= ~GPIO_CRH_MODE10;	// Set MODE bit 10 to Mode 00 = input
	GPIOA->BSRR = GPIO_BSRR_BS10;     //	Enable PULL UP
	temp = USART1->SR;	//Clear pending
	temp = USART1->DR;
	
	// USART2 
	USART2->BRR = (234<<4)|0x06;		// Baudrate for 9600 on 36Mhz
	USART2->CR1  |= USART_CR1_UE | USART_CR1_TE | USART_CR1_RE | USART_CR1_RXNEIE; // USART2 ON, TX ON, RX ON
	//TX2 on PINA2
	GPIOA->CRL	&= ~GPIO_CRL_CNF2; 				// Clear CNF bit 2
	GPIOA->CRL	|= GPIO_CRL_CNF2_1;				// Set CNF bit 2 to 10 - AFIO Push-Pull
	GPIOA->CRL	|= GPIO_CRL_MODE2_0;				// Set MODE bit 2 to Mode 01 = 10MHz
	//RX2 on PINA3	
	GPIOA->CRL	&= ~GPIO_CRL_CNF3;	// Clear CNF bit 3
	GPIOA->CRL	|= GPIO_CRL_CNF3_1;	// Set CNF bit 3 to "10" = PullUp
	GPIOA->CRL	&= ~GPIO_CRL_MODE3;	// Set MODE bit 3 to Mode 00 = input
	GPIOA->BSRR = GPIO_BSRR_BS3; //	Enable PULL UP
	temp = USART2->SR;		//Clear pending
	temp = USART2->DR;

	// USART3 
	USART3->BRR = (234<<4)|0x06;		// Baudrate for 9600 on 36Mhz
	USART3->CR1  |= USART_CR1_UE | USART_CR1_TE | USART_CR1_RE | USART_CR1_RXNEIE; // USART3 ON, TX ON, RX ON
	
	//TX3 on PINB10
	GPIOB->CRH	&= ~GPIO_CRH_CNF10; 				// Clear CNF bit 2
	GPIOB->CRH	|= GPIO_CRH_CNF10_1;				// Set CNF bit 2 to 10 - AFIO Push-Pull
	GPIOB->CRH	|= GPIO_CRH_MODE10_0;				// Set MODE bit 2 to Mode 01 = 10MHz
	//RX2 on PINB11	
	GPIOB->CRH	&= ~GPIO_CRH_CNF11;	// Clear CNF bit 3
	GPIOB->CRH	|= GPIO_CRH_CNF11_1;	// Set CNF bit 3 to "10" = PullUp
	GPIOB->CRH	&= ~GPIO_CRH_MODE11;	// Set MODE bit 3 to Mode 00 = input
	GPIOB->BSRR = GPIO_BSRR_BS11;     //	Enable PULL UP
	temp = USART1->SR;		//Clear pending
	temp = USART1->DR;
	
	NVIC_ClearPendingIRQ(USART1_IRQn);
	NVIC_ClearPendingIRQ(USART2_IRQn);
//	NVIC_ClearPendingIRQ(USART3_IRQn);
	//UART INT ON
	NVIC_EnableIRQ (USART1_IRQn);
	NVIC_EnableIRQ (USART2_IRQn);
//	NVIC_EnableIRQ (USART3_IRQn);
};


void USART1_IRQHandler(void)
{
	uint16_t data;
  volatile unsigned int IIR;
	IIR = USART1->SR;	// Get status flags
	
	if (IIR & USART_SR_RXNE)	{				// read interrupt
		data = USART1->DR;
		USART1->DR = data + 1;
	}
}


void USART2_IRQHandler (void)
{
  volatile unsigned int IIR;
	IIR = USART1->SR;	// Get status flags
	
	if (IIR & USART_SR_RXNE)	{				// read interrupt
		USART1->DR = USART2->DR;		//forward to USART1
	} 
}

void USART3_IRQHandler (void)
{
  volatile unsigned int IIR;
	IIR = USART1->SR;	// Get status flags
	
	if (IIR & USART_SR_RXNE)	{				// read interrupt
		USART1->SR &= ~USART_SR_RXNE;	  // clear interrupt
		USART3->DR = (USART3->DR)+100;
	}
	
	// transmit
	if (IIR & USART_SR_TXE) {					//transmit empty
      USART1->SR &= ~USART_SR_TXE;	          // clear interrupt
			USART1->DR = USART3->DR;				// forward to USART1
/*      p = &tbuf;
      if (p->in != p->out) {
        USART1->DR = (p->buf [p->out & (TBUF_SIZE-1)] & 0x1FF);
        p->out++;
        tx_restart = 0;
      }
      else {
        tx_restart = 1;
				USART1->CR1 &= ~USART_FLAG_TXE;		      // disable TX interrupt if nothing to send

      }
*/
    }
};


/*

//----------------------------------------------------------------------------
//  USART1_IRQHandler
//  Handles USART1 global interrupt request.
//----------------------------------------------------------------------------
void USART1_IRQHandler (void) {
  volatile unsigned int IIR;
  struct buf_st *p;

    IIR = USART1->SR;
    if (IIR & USART_FLAG_RXNE) {                  // read interrupt
      USART1->SR &= ~USART_FLAG_RXNE;	          // clear interrupt

      p = &rbuf;

      if (((p->in - p->out) & ~(RBUF_SIZE-1)) == 0) {
        p->buf [p->in & (RBUF_SIZE-1)] = (USART1->DR & 0x1FF);
        p->in++;
      }
    }

    if (IIR & USART_FLAG_TXE) {
      USART1->SR &= ~USART_FLAG_TXE;	          // clear interrupt

      p = &tbuf;

      if (p->in != p->out) {
        USART1->DR = (p->buf [p->out & (TBUF_SIZE-1)] & 0x1FF);
        p->out++;
        tx_restart = 0;
      }
      else {
        tx_restart = 1;
		USART1->CR1 &= ~USART_FLAG_TXE;		      // disable TX interrupt if nothing to send

      }
    }
}


*/

